<template :scheduleItem="scheduleItem">
  <ValidationObserver v-slot="{ handleSubmit }">
    <CForm
      v-loading="loading"
      class="Schedule-form"
      @submit.prevent="handleSubmit(onSubmit)"
    >
      <CCard>
        <CCardBody>
          <div class="box-inner-form">
            <div class="row">
              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CInput
                    v-model="model.name"
                    type="text"
                    label="Name"
                    placeholder="Enter name"
                    horizontal
                  >
                    <template #prepend-content>
                      <font-awesome-icon :icon="['fas', 'user-tie']" class="width-1x" />
                    </template>
                    <template #invalid-feedback>
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </template>
                  </CInput>
                </ValidationProvider>
              </div>

              <div class="col-12 col-lg-6">
                <ValidationProvider v-slot="{ errors }" rules="required">
                  <CSelect
                    v-model="model.object_id"
                    label="Select Groups"
                    horizontal
                    :options="objects"
                    placeholder="Please select"
                    :value.sync="model.object_id"
                  />
                  <div class="d-block invalid-feedback">
                    {{ errors[0] }}
                  </div>
                </ValidationProvider>
              </div>
            </div>
            <div class="row">
              <div class="col-12 col-lg-6">
                <div class="form-group form-row">
                  <label class="col-form-label col-sm-3"> Date </label>
                  <div class="col-sm-9 input-group">
                    <ValidationProvider name="date_on">
                      <date-picker v-model="model.date_range" type="date" range value-type="timestamp" />
                    </ValidationProvider>
                  </div>
                </div>
              </div>

              <div class="col-12 col-lg-6">
                <div class="form-group form-row">
                  <label class="col-form-label col-sm-3"> Time </label>
                  <div class="col-sm-9 input-group">
                    <ValidationProvider v-slot="{ errors }" rules="required">
                      <date-picker v-model="model.time_range" type="time" range value-type="timestamp" />
                      <div class="d-block invalid-feedback">
                        {{ errors[0] }}
                      </div>
                    </ValidationProvider>
                  </div>
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col-12 col-lg-6">
                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label">
                    Day of weeks
                  </CCol>
                  <CCol sm="9" class="form-inline">
                    <app-checkbox-group v-model="model.days_of_week" :list="daysOfWeek" :name="'day'" />
                  </CCol>
                </div>
              </div>

              <div class="col-12 col-lg-6">
                <div role="group" class="form-group form-row">
                  <CCol tag="label" sm="3" class="col-form-label">
                    Status
                  </CCol>
                  <CCol sm="9" class="form-inline">
                    <app-radio-group v-model="model.status" :list="statusList" :name="'status'" />
                  </CCol>
                </div>
              </div>
            </div>
            <div class="row">
              <div class="col-12 col-lg-6">
                <CTextarea
                  v-model="model.description"
                  label="Description"
                  placeholder="Description"
                  horizontal
                  rows="5"
                >
                  <template #prepend-content>
                    <font-awesome-icon :icon="['fas', 'list-ul']" class="width-1x" />
                  </template>
                </CTextarea>
              </div>
            </div>
          </div>
        </CCardBody>

        <CCardFooter>
          <CButton
            type="submit"
            color="primary"
          >
            <font-awesome-icon :icon="['fas', 'save']" class="width-1x" />
            Save
          </CButton>

          <CButton
            color="secondary"
            @click="$emit('close')"
          >
            Cancel
          </CButton>
        </CCardFooter>
      </CCard>
    </CForm>
  </ValidationObserver>
</template>

<script>
import DatePicker from 'vue2-datepicker'
import Group from '~/models/Group'
import Schedule from '~/models/Schedule'
import AppCheckboxGroup from '~/components/atoms/AppCheckboxGroup'
import AppRadioGroup from '~/components/atoms/AppRadioGroup'
import createEditForm from '~/mixins/create-edit-form'
import { DAYS_OF_WEEK } from '~/constants/index'
import 'vue2-datepicker/index.css'

const statusList = [
  {
    id: 1,
    name: 'ON'
  },
  {
    id: 0,
    name: 'OFF'
  }
]

export default {
  components: { AppCheckboxGroup, AppRadioGroup, DatePicker },
  mixins: [createEditForm],

  data () {
    return {
      statusList,
      model: new Schedule(),
      modelType: 'schedule',
      daysOfWeek: DAYS_OF_WEEK,
      objects: [],
      loading: false
    }
  },

  methods: {
    /**
     * set user status
     * @param {Boolean} val
     * @param {Object} event
     */
    setStatus (val, event) {
      this.model.status = parseInt(event.target.value)
    },

    /**
     * Dynamic set model
     * @param {Object} data
     */
    setModel (data) {
      this.model = new Schedule(data)
    },

    /**
     * Prepare form data
     */
    prepareData () {
      // TODO get object by type
      this.$dam.getGroupList()
        .then((res) => {
          this.objects = res.data.map((item) => {
            return {
              ...new Group(item),
              label: item.name,
              value: item.id
            }
          })
        })
        .catch(err => console.error(err))
    }
  }
}
</script>

<style lang="scss">
  .box-content {
    max-width: 900px;
    margin: auto;
  }
</style>
